package io.zipcoder;

/**
 * Make this extend the Copier like `UnsafeCopier`, except use locks to make sure that the actual intro gets printed
 * correctly every time.  Make the run method thread safe.
 * https://www.journaldev.com/2377/java-lock-example-reentrantlock
 */

import java.util.*;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class SafeCopier  extends Copier{
    public SafeCopier(String toCopy) {
        super(toCopy);
    }
    private Lock lock=new ReentrantLock();
    public void run() {
        lock.lock();
        while(stringIterator.hasNext())
        {
            copied=copied+stringIterator.next() + " ";
        }
        lock.unlock();
    }
}
